// smtools.js
// timeouts changed to 10 seconds
// xmlhttp objects used: for now, maintain original code ones mostly
var sxinit = false;  // initial sequencer
var sxaction = false; // action routine: no data returned
			// also use for the RESET although different cgi
var xmlhttps = false;  // manual control: for status
			// use same action one
var xmlhttpports = false;  // specials,  for sending data
var xmlhttpportr = false;   // specials, for getting data

// timers:
var timeoutidinit;	// for initializing
var timeoutidc;		// for action routine
var timeoutidcs;	// specials, for sending
var timeoutidcr;	// specials, for recving
var timeoutids;		// for manl, status request
var timeoutidrst;	// for 2.5 sec delay after restarting
var srefreshtimerid;	// for manl, refresh timer

// control of sections
var tstactive;
var manlactive;
var rstactive;
var specactive;


// other global variables
var stimeouts=0;  // so know if get timeout errors
var srefreshtime;
var specials;  // created by makespecials();



var sequencecount = 4;
var sequencelist = new Array(4);
var sequencendx;
// string tells what to do: start with C or S
sequencelist[0] = "CVA";  // main firmware
sequencelist[1] = "CVR";  // Rabbit firmware
sequencelist[2] = "SI";    // serial number(s)
sequencelist[3] = "CIC";  // current IP etc.

if (window.XMLHttpRequest)
  {
  sxinit = new XMLHttpRequest();
  sxaction = new XMLHttpRequest();
  xmlhttps = new XMLHttpRequest();
  xmlhttpports = new XMLHttpRequest();
  xmlhttpportr = new XMLHttpRequest();
  }
else if (window.ActiveXObject)
  {
  sxinit = new ActiveXObject("Microsoft.XMLHTTP");
  sxaction = new ActiveXObject("Microsoft.XMLHTTP");
  xmlhttps = new ActiveXObject("Microsoft.XMLHTTP");
  xmlhttpports = new ActiveXObject("Microsoft.XMLHTTP");
  xmlhttpportr = new ActiveXObject("Microsoft.XMLHTTP");
  }
else
  {
  alert("Browser does not support XmlHttpRequest object, ie Ajax: upgrade");
  }





function doalert(str)
// really want to put in alert field - later
  {
  alert(str);
  }

function sysalert(str)
// should be impossible; error in Javascript
  {
  alert("SYSTEM ERROR:\n" + str);
  }



function dosequencer()
  {
  var url;
  var ajaxmsg;
  var x;
  x=sequencelist[sequencendx].charAt(0);
  if (x=='C') url="config.cgi";
  else if (x=='S') url="status.cgi";
  else
    {
    doalert("Bad sequencer element - aborting");
    return;
    }
  ajaxmsg = sequencelist[sequencendx].slice(1);  // start after first char
  if ( (sxinit.readyState==4) || (sxinit.readyState==0) )
    {
    sxinit.open("POST", url, true);
    sxinit.onreadystatechange = sxinitreturn;
    sxinit.send(ajaxmsg);
    timeoutidinit = window.setTimeout("timeoutrtninit();", 10000);
    }
  else
    {
    doalert("Sequencer stuck - aborting");
    return;
    }
  }


function timeoutrtninit()
  {
  // get here if sequencer times out - allow 5 before alerting
  // no - not alerting at all now; but might put back in
  dosequencer();  // continue to try
  }

function tools_initialize()
  {
  tstactive=0;
  document.getElementById("tstmainbutton").value = "Activate";
  manlactive=0;
  document.getElementById("manlmainbutton").value = "Activate";
  rstactive=0;
  document.getElementById("rstmainbutton").value = "Activate";
  specactive=0;
  document.getElementById("specmainbutton").value = "Activate";
  sequencendx=0;
  dosequencer();  // will enable buttons and start refresh when done
  }
function findkeypos(str)
  {
  // return the position of the "key" in str
  // key can be ! or _ or : or ^
  // has to be 0, 1, or 2: else no key, return0
  var pos;
  pos = str.search(/[\!\:\_\^]/);
  if (pos==-1) pos=0;
  if (pos>2) pos=0;
  return pos;
  }



function sxinitreturn()
  {
  var str0;
  var keypos;
  var str1;
  var splitstr;
  // check to see if finished
  if ( (sxinit.readyState==4) && (sxinit.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidinit);
    numtimeouts=0;
    str0 = sxinit.responseText;
    keypos = findkeypos(str0);
    if (str0.charAt(keypos) != ":")
      {
      // error return - should be impossible
      doalert("Unexpected response [" + str0 + "]");
      dosequencer();  // keep retrying
      return;
      }
    // here, is ok
    // we know where it came from: don't need to parse
    str1 = str0.slice(keypos+1);
    badresp=0;  // default
    if (sequencendx==0)
	{
	// VA to config: get main firmware
	splitarray = str1.split("$");
	if (splitarray.length!=4) badresp=1;
	document.getElementById("mainfw").innerHTML = splitarray[0];
	}
    else if (sequencendx==1)
	{
	// VR to config: get comm firmware
	document.getElementById("commfw").innerHTML = str1;
	}
    else if (sequencendx==2)
	{
	// I to status: get serial numbers
	splitarray = str1.split(";");
	if (splitarray.length!=3) badresp=1;
	document.getElementById("sernum").innerHTML = splitarray[2];
	}
    else if (sequencendx==3)
	{
	// IC to config: current IP etc.
	splitarray = str1.split(";");
	if (splitarray.length!=6) badresp=1;
	document.getElementById('currentip').innerHTML = splitarray[0];
	document.getElementById('currentmask').innerHTML = splitarray[1];
	document.getElementById('currentgate').innerHTML = splitarray[2];
	document.getElementById('currentname').innerHTML = splitarray[3];
	document.getElementById('currentmac').innerHTML = splitarray[4];
	}
    else
	{
	sysalert("Error: sequencendx=" + sequencendx);
	sequencendx=3;  // abort sequence
	}
    if (badresp) doalert("Bad response: [" + str0 + "]");
    if (sequencendx==3)
	{
	// end of sequencer
	sequencendx=0;
	}
    else
	{
	sequencendx++;
	dosequencer();
	}
    }
  }


// general utilities

function tointeger(fval)
  {
  return parseInt(fval.toFixed(), 10);
  }


function bytetohex(x)
  {
  // convert to 2-digit hex string; assume is byte
  if (x>=0x10) return x.toString(16);
  else return "0" + x.toString(16);
  }


function wordtohex(x)
  {
  // convert 16-bit integer to 4-digit hex string: low then high
  var high, low;
  low = x&0xff;
  high = (x>>8) & 0xff;
  return bytetohex(low) + bytetohex(high);
  }





// use same action routine for everybody that needs it
// to simplify life, use same routine for reboot command
// but it goes to different url - check for text
function actionrtn(param)
  {
  var url;
  if (param=="RESET2!!") url="config.cgi"; else url="status.cgi";
  // use XmlHttpRequest to get string from server
  if ( (sxaction.readyState==4) || (sxaction.readyState==0) )
     {
     // ok to do it: set up as POST request to whatever
     sxaction.open("POST", url, true);
     // set up function to be called when state changes
     sxaction.onreadystatechange = actionrtnret;
     sxaction.send(param);  // send it
     timeoutidc = window.setTimeout("timeoutrtnact();", 10000);
     }
  }

function actionrtnret()
  {
  // action rtn now also used for K commands - manual mode
  // but process response differently
  var str0;
  var str1;
  var keypos;
  var prestr;
  if ((sxaction.readyState==4) && (sxaction.status==200) )  
    {
    window.clearTimeout(timeoutidc);
    str0 = sxaction.responseText;
    if (str0.charAt(0)=='K')
	{
	// really a manual mode request
	processmastring(str0);
	return;
	}
    str1 = str0.slice(keypos+1);
    keypos = findkeypos(str0);
    if (str1.charAt(keypos) == "!")
	{
	// error condition: alert and return
	alert(str1);
	return;
	}
    if (str1.charAt(keypos) == '^')
	{
	// this should only happen with reset; but check it out
	prestr=str0.slice(0,keypos);  // tells which command it was
	if (prestr=="R2")
	  {
	  // resetting: put in message, remove after timeout
	  document.getElementById("resetmessage").innerHTML = "Rebooting";
	  timeoutidrst = window.setTimeout("timeoutrtnrst();", 2500);
	  // remove message after 2.5 seconds
	  }
	else alert("Unexpected return: [" + instr0 + "]");
	}
    // if ok - just do nothing
    }
  }


function timeoutrtnact()
  {
  // gets called if the xmlhttp request times out
  // clear it and reenable the window; also alert
  sxaction.abort();
  doalert("Request timed out");
  }


function timeoutrtnrst()
  {
  // gets called if we get a "rebooting" response to reboot command
  // clears the message
  document.getElementById("resetmessage").innerHTML = "";
  }

// ************************************************************************
// activation
function rstflipactive()
  {
  if (rstactive)
    {
    killrst();
    rstactive=0;
    document.getElementById("rstmainbutton").value = "Activate";
    }
  else
    {
    initializerst();
    rstactive=1;
    document.getElementById("rstmainbutton").value = "Deactivate";
    }
  }


// rst has nothing special in initialize/killing it
function initializerst()
  {
  document.getElementById("rstdiv").style.display = "block";
  }

function killrst()
  {
  document.getElementById("rstdiv").style.display = "none";
  }


function tstflipactive()
  {
  if (tstactive)
    {
    killtst();
    tstactive=0;
    document.getElementById("tstmainbutton").value = "Activate";
    }
  else
    {
    initializetst();
    tstactive=1;
    document.getElementById("tstmainbutton").value = "Deactivate";
    }
  }


// tst has nothing special in initialize/killing it
function initializetst()
  {
  document.getElementById("tstdiv").style.display = "block";
  }

function killtst()
  {
  document.getElementById("tstdiv").style.display = "none";
  }


function manlflipactive()
  {
  if (manlactive)
    {
    killmanl();
    manlactive=0;
    document.getElementById("manlmainbutton").value = "Activate";
    }
  else
    {
    initializemanl();
    manlactive=1;
    document.getElementById("manlmainbutton").value = "Deactivate";
    }
  }


// manl has the timer
function initializemanl()
  {
  document.getElementById("manldiv").style.display = "block";
  // initialize to every second
  but=document.srefreshform.rgroup;
  but[1].checked=1;  // refresh every second
  setsrefresh(1000);
  getstatus();
  }

function killmanl()
  {
  // kill timer
  setsrefresh(0);  // kill refresh
  document.getElementById("manldiv").style.display = "none";
  }


function specflipactive()
  {
  if (specactive)
    {
    killspec();
    specactive=0;
    document.getElementById("specmainbutton").value = "Activate";
    }
  else
    {
    initializespec();
    specactive=1;
    document.getElementById("specmainbutton").value = "Deactivate";
    }
  }


// spec - initialize when we come up
function initializespec()
  {
  document.getElementById("specdiv").style.display = "block";
  clearspecials();
  fetchparams();
  // fetch current values
  }

function killspec()
  {
  // nothing special to do when quitting
  document.getElementById("specdiv").style.display = "none";
  }


// ************************************************************************
// manual mode
function timeoutrtns()
  {
  // gets called if the xmlhttp request times out
  // clear it and reenable the window; also alert
  xmlhttps.abort();
  scondalert("Request timed out");
// and restart timer
  window.clearTimeout(srefreshtimerid);
  if (srefreshtime)
       srefreshtimerid=window.setTimeout("srefreshrtn();", srefreshtime);
  stimeouts++;
  document.getElementById('stimeouts').innerHTML = stimeouts;
  
  }

function scondalert(str)
{
// do NOT want to alert timeouts etc when doing automatics
// since nobody is there maybe to clear it!
if (srefreshtime==0) alert(str);
}

function condgetstatus()
{
// do not do it if refresh is off
if (srefreshtime==0) getstatus();
}


function getstatus()
  {
  // get status info from SM, display on screen when returns
  if ( (xmlhttps.readyState==4) || (xmlhttps.readyState==0) )
     {
     // ok to do it: set up as POST request
     xmlhttps.open("POST", "status.cgi", true);  // asynchronous, POST
     // set up function to be called when state changes
     xmlhttps.onreadystatechange = getstatusreturn;
     xmlhttps.send("X?");
     timeoutids = window.setTimeout("timeoutrtns();", 10000);
     }
  else scondalert("Busy");
  }


function getstatusreturn()
  {
  var instr0;
  var instr1;
  var keypos;
  var splitarray;   // 4 fields,with semicolon terminators
  var str;
  // check to see if finished
  if ((xmlhttps.readyState==4) && (xmlhttps.status==200) )  
    {
    window.clearTimeout(timeoutids);
    window.clearTimeout(srefreshtimerid);
    if (srefreshtime)
       srefreshtimerid=window.setTimeout("srefreshrtn();", srefreshtime);
    // write values into form, IF valid
    instr0 = xmlhttps.responseText;
    keypos = findkeypos(instr0);
    instr1 = instr0.slice(keypos+1);
    if (instr0.charAt(keypos) == "!")
	{
	// error condition: alert and return
	scondalert(instr1);
	return;
	}
    // first char not ! : is ok - process it
    splitarray = instr1.split(";");
    if (splitarray.length != 5)
	{
	// unexpected
	scondalert("Unexpected result: "+instr1);
	return;
	}
    // process info
    str = splitarray[0];  // should be the abbreviation for major state
    document.getElementById('majorstate').innerHTML = msdecode(str);
    document.getElementById('pressure').innerHTML = splitarray[1];
    document.getElementById('temperature').innerHTML = splitarray[2];
    processios(splitarray[3]);
    }
  }


function msdecode(str)
  {
  // from single-letter to word
  var msg;
  var abbrev;
  x=str.charAt(0);
  if (x=="S") msg="Standalone";
  else if (x=='R')
     {
     msg="Redundant (using port " + str.charAt(1) + ")" ;
     abbrev = abbrev+str.charAt(1);
     }
  else if (x=='P') msg="Parallel";
  else if (x=='T') msg="Testing";
  else if (x=='I') msg="Transient";
  else if (x=='X') msg="PROBLEM";
  else if (x=='C') msg="Comm init.";
  else if (x=='M') msg="Manual";
  else if (x=='O') msg="Offline";
  else msg="???";
  return msg;
  }

function processios(str)
  {
  var xhi,xlo;
  var ok=1;
  if (str.match(/[^0-9A-Fa-f]/) != null) ok=0;
  if (str.length != 4) ok=0;
  if (!ok)
    {
    alert("Bad alarm string: " + str);
    return;
    }
  // here, ok - will always be, most likely
  xhi = parseInt(str.substring(0,2),16);
  xlo = parseInt(str.substring(2,4),16);
// do the dumb way, at least for now
  document.getElementById('z8000').innerHTML= (xhi&0x80) ? "ON" : "--";
  document.getElementById('z4000').innerHTML= (xhi&0x40) ? "ON" : "--";
  document.getElementById('z2000').innerHTML= (xhi&0x20) ? "ON" : "--";
  document.getElementById('z1000').innerHTML= (xhi&0x10) ? "ON" : "--";
  document.getElementById('z0800').innerHTML= (xhi&0x08) ? "ON" : "--";
  document.getElementById('z0400').innerHTML= (xhi&0x04) ? "ON" : "--";
  document.getElementById('z0200').innerHTML= (xhi&0x02) ? "ON" : "--";
  document.getElementById('z0100').innerHTML= (xhi&0x01) ? "ON" : "--";

//document.getElementById('z0080').innerHTML= (xlo&0x80) ? "ON" : "--";
//document.getElementById('z0040').innerHTML= (xlo&0x40) ? "ON" : "--";
  document.getElementById('z0020').innerHTML= (xlo&0x20) ? "ON" : "--";
  document.getElementById('z0010').innerHTML= (xlo&0x10) ? "ON" : "--";
  document.getElementById('z0008').innerHTML= (xlo&0x08) ? "ON" : "--";
  document.getElementById('z0004').innerHTML= (xlo&0x04) ? "ON" : "--";
  document.getElementById('z0002').innerHTML= (xlo&0x02) ? "ON" : "--";
  document.getElementById('z0001').innerHTML= (xlo&0x01) ? "ON" : "--";
  }


function srefreshrtn()
  {
  // gets called when refresh timer runs out: just get info
  getstatus();
  }



function setsrefresh(param)
  {
  srefreshtime = param;
  window.clearTimeout(srefreshtimerid);
  if (srefreshtime)
	{
	document.getElementById("getstatus").disabled=true;
        srefreshtimerid=window.setTimeout("srefreshrtn();", srefreshtime);
	}
  else document.getElementById("getstatus").disabled=false;
  }


function sendios()
  {
  var param;
  var xhi, xlo;
  xhi=0;
  if (document.ioform.c8000.checked) xhi |= 0x80;
  if (document.ioform.c4000.checked) xhi |= 0x40;
  if (document.ioform.c2000.checked) xhi |= 0x20;
  if (document.ioform.c1000.checked) xhi |= 0x10;
  if (document.ioform.c0800.checked) xhi |= 0x08;
  if (document.ioform.c0400.checked) xhi |= 0x04;
  if (document.ioform.c0200.checked) xhi |= 0x02;
  if (document.ioform.c0100.checked) xhi |= 0x01;
  xlo=0;
//if (document.ioform.c0080.checked) xlo |= 0x80;
//if (document.ioform.c0040.checked) xlo |= 0x40;
//if (document.ioform.c0020.checked) xlo |= 0x20;
  if (document.ioform.c0010.checked) xlo |= 0x10;
  if (document.ioform.c0008.checked) xlo |= 0x08;
  if (document.ioform.c0004.checked) xlo |= 0x04;
  if (document.ioform.c0002.checked) xlo |= 0x02;
  if (document.ioform.c0001.checked) xlo |= 0x01;

  param = "X=" + bytetohex(xhi) + bytetohex(xlo);
  // now send to SM1
  actionrtn(param);
  }

// *******************************************************************
// special port parameters

function fetchparams()
  {
  // get test paramss from ADH, display in form
  if ( (xmlhttpportr.readyState==4) || (xmlhttpportr.readyState==0) )
     {
     // ok to do it: set up as POST request
     xmlhttpportr.open("POST", "config.cgi", true);  // asynchronous, POST
     // set up function to be called when state changes
     xmlhttpportr.onreadystatechange = fetchparamsreturn;
     xmlhttpportr.send("TP");
     timeoutidcr = window.setTimeout("timeoutrtncr();", 10000);
     }
  else alert("Busy");
  }


function fetchparamsreturn()
  {
  var instr0;
  var keypos;
  var instr1;
  var splitarray;
  // check to see if finished
  if ((xmlhttpportr.readyState==4) && (xmlhttpportr.status==200) )  
    {
    window.clearTimeout(timeoutidcr);
    // write values into form, IF valid
    instr0 = xmlhttpportr.responseText;
    keypos = findkeypos(instr0);
    instr1 = instr0.slice(keypos+1);
    if (instr0.charAt(keypos) == "!")
	{
	// error condition: alert and return
	alert(instr1);
	return;
	}
    // first char not ! : is ok - process it
    splitarray = instr1.split(";");
    if (splitarray.length != 10)
	{
	// unexpected
	alert("Unexpected result: "+instr1);
	return;
	}
    document.testparams.tpfreq.value = splitarray[0];
    document.testparams.tpdc.value   = splitarray[1];
    document.testparams.tpstall.value = splitarray[2];
    document.testparams.tpsmlr.value = splitarray[3];
    document.testparams.tpiwlr.value = splitarray[4];
    document.testparams.tpowlr.value = splitarray[5];
    document.testparams.tpoalr.value = splitarray[6];
    document.testparams.tpoklr.value = splitarray[7];
    clearspecials();  // set them again if there are any
    if (splitarray[8] != "")
      {
      if (parsespecials(splitarray[8]))
	{
	alert("Error in special string [" + splitarray[8] + "]");
	clearspecials();
	}
      }
    }
  }


function parsespecials(str)
  {
//  return 1 if error, 0 if ok
// only error is length of string wrong
  var numins;
  var numouts;
  var inmask;
  var outmask;
  var ndx;
  var bitmask;
  var elt;
  var eltiw;
  var eltow;
  var eltoa;
  var eltok;
  var pos;
  var xlo;
  var xhi;
  if (str.length<4) return 1;
  inmask = parseInt(str.substring(0,2),16);
  outmask = parseInt(str.substring(2,4),16);
  if (inmask & outmask) return 1;  // can't intersect
  // count bits
  numins=0;
  numouts=0;
  for (ndx=1,bitmask=1; ndx<=8; ndx++, bitmask<<=1)
    {
    if (bitmask&inmask) numins++;
    if (bitmask&outmask) numouts++;
    }
  if (str.length != 2*(2+numins+4*numouts) ) return 1;  // wrong length
  // here, length ok: proceed
  // do inputs first
  pos=4;
  for (ndx=1,bitmask=1; ndx<=8; ndx++, bitmask<<=1)
    {
    if (bitmask&inmask)
	{
	elt   = document.getElementById("p" + ndx + "type");
	eltiw = document.getElementById("p" + ndx + "iw");
	eltow = document.getElementById("p" + ndx + "ow");
	eltoa = document.getElementById("p" + ndx + "oa");
	eltok = document.getElementById("p" + ndx + "ok");
	elt.selectedIndex = 1;  // input
	eltiw.value = parseInt(str.substring(pos,pos+2),16);
	eltiw.disabled=0;
	eltow.value = "";
	eltow.disabled=1;
	eltoa.value = "";
	eltoa.disabled=1;
	eltok.value = "";
	eltok.disabled=1;
	pos+=2;
	}
    }
  // now outputs
  for (ndx=1, bitmask=1; ndx<=8;  ndx++, bitmask<<=1)
    {
    if (bitmask&outmask)
	{
	elt   = document.getElementById("p" + ndx + "type");
	eltiw = document.getElementById("p" + ndx + "iw");
	eltow = document.getElementById("p" + ndx + "ow");
	eltoa = document.getElementById("p" + ndx + "oa");
	eltok = document.getElementById("p" + ndx + "ok");
	elt.selectedIndex = 2;  // output
	eltiw.value = "";
	eltiw.disabled=1;
	eltow.value = parseInt(str.substring(pos,pos+2),16);
	eltow.disabled=0;
	eltoa.value = parseInt(str.substring(pos+2,pos+4),16);
	eltoa.disabled=0;
//	eltok.value = parseInt(str.substring(pos+4,pos+8),16);
// can't use that: is low then high in the string
	xlo = parseInt(str.substring(pos+4,pos+6),16);
	xhi = parseInt(str.substring(pos+6,pos+8),16);
	eltok.value = (256*xhi) + xlo;
	eltok.disabled=0;
	pos += 8;
	}
    }
  }



function makespecials()
  {
  // return 1 if error, 0 if ok
  // if ok, put results in string specials
  var instr;  // the part for the input ports
  var outstr;  // ditto for output ports
  var numins;
  var numouts;
  var inmask;
  var outmask;
  var ndx;
  var bitmask;
  var elt;
  var eltiw;
  var eltow;
  var eltoa;
  var eltok;
  var x;
  var fltval;
  var ival1,ival2,ival3;
  numins=0;
  numouts=0;
  inmask=0;
  outmask=0;
  instr="";
  outstr="";
  for (ndx=1, bitmask=1; ndx<=8;  ndx++, bitmask<<=1)
    {
    elt = document.getElementById("p" + ndx + "type");
    if (elt.selectedIndex==1)
	{
	// input
	numins++;
	inmask |= bitmask;
	eltiw = document.getElementById("p" + ndx + "iw");
	fltval = parseFloat(eltiw.value,10);
	if (isNaN(fltval)) return 1;
	else if (fltval<1) return 1;
	else if (fltval>250) return 1;
	ival1 = tointeger(fltval);
	instr = instr + bytetohex(ival1);
	}
    else if (elt.selectedIndex==2)
	{
	// output
	numouts++;
	outmask |= bitmask;
	eltoa = document.getElementById("p" + ndx + "oa");
	eltok = document.getElementById("p" + ndx + "ok");
	eltow = document.getElementById("p" + ndx + "ow");
	fltval = parseFloat(eltow.value,10);
	if (isNaN(fltval)) return 1;
	else if (fltval<1) return 1;
	else if (fltval>250) return 1;
	ival1 = tointeger(fltval);
	fltval = parseFloat(eltoa.value,10);
	if (isNaN(fltval)) return 1;
	else if (fltval<1) return 1;
	else if (fltval>250) return 1;
	ival2 = tointeger(fltval);
	fltval = parseFloat(eltok.value,10);
	if (isNaN(fltval)) return 1;
	else if (fltval<1) return 1;
	else if (fltval>999) return 1;
	ival3 = tointeger(fltval);
	outstr = outstr+bytetohex(ival1)+bytetohex(ival2)+wordtohex(ival3);
	}
    }
  // now put them all together
  if (numins+numouts > 35)
    {
    // special case: this could happen, may not be obvious; do extra alert
    alert("Too many special parameters");
    return 1;
    }
  if ( (numins==0) && (numouts==0) )
    specials = "";  // none defined: leave it blank
  else
    specials = bytetohex(inmask) + bytetohex(outmask) + instr + outstr;
  return 0;
  }

function submitparams()
  {
  // either English or metric, depending on form
  var param;
  var fltval;  // from form: floating point, in PSI
  var freq, dc, stall, smlr, iwlr, owlr, oalr, oklr;  // convert to integers
  var isok;
  var minval, maxval;
  // first put together the parameter string
  isok=1;
  // so can use same functions: have zerook, maxval
  if (isok)
    {
    // freq: 0-999
    minval=0;
    maxval=999;
    fltval = parseFloat(document.testparams.tpfreq.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else freq = tointeger(fltval);
    }
  if (isok)
    {
    // dc: 1-100
    minval=1;
    maxval=100;
    fltval = parseFloat(document.testparams.tpdc.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else dc = tointeger(fltval);
    }
  if (isok)
    {
    // stall: 1-60
    minval=1;
    maxval=60;
    fltval = parseFloat(document.testparams.tpstall.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else stall = tointeger(fltval);
    }
  if (isok)
    {
    // smlr: 1-250
    minval=1;
    maxval=250;
    fltval = parseFloat(document.testparams.tpsmlr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else smlr = tointeger(fltval);
    }

  if (isok)
    {
    // iwlr: 1-250
    minval=1;
    maxval=250;
    fltval = parseFloat(document.testparams.tpiwlr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else iwlr = tointeger(fltval);
    }
  if (isok)
    {
    // owlr: 1-250
    minval=1;
    maxval=250;
    fltval = parseFloat(document.testparams.tpowlr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else owlr = tointeger(fltval);
    }
  if (isok)
    {
    // oalr: 1-250
    minval=1;
    maxval=250;
    fltval = parseFloat(document.testparams.tpoalr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else oalr = tointeger(fltval);
    }
  if (isok)
    {
    // oklr: 1-999
    minval=1;
    maxval=999;
    fltval = parseFloat(document.testparams.tpoklr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else oklr = tointeger(fltval);
    }
  if (!isok)
    {
    alert("Error in global parameters");
    return;
    }
  if (makespecials())
    {
    // puts result into string specials
    alert("Error in special parameters");
    return;
    }
  param = "T="+freq+";"+dc+";"+stall+";"
	+smlr+";"+iwlr+";"+owlr+";"+oalr+";"+oklr+";" + specials + ";"
  if ( (xmlhttpports.readyState==4) || (xmlhttpports.readyState==0) )
     {
     // ok to do it: set up as POST request
     xmlhttpports.open("POST", "config.cgi", true);  // asynchronous, POST
     // set up function to be called when state changes
     xmlhttpports.onreadystatechange = submitparamsreturn;
     xmlhttpports.send(param);
     timeoutidcs = window.setTimeout("timeoutrtncs();", 10000);
     }
  else alert("Busy");
  }


function submitparamsreturn()
  {
  var str0;
  var str1;
  var keypos;
  var key;
  // check to see if finished
  if ((xmlhttpports.readyState==4) && (xmlhttpports.status==200) )  
    {
    window.clearTimeout(timeoutidcs);
    str0 =  xmlhttpports.responseText;
    keypos = findkeypos(str0);
    key = str0.charAt(keypos);
    if ( (key != "_") && (key != "!") && (key != "^") )
	{
	alert("Unexpected result: [" + str0 + "]");
	return;
	}
    str1 = str0.slice(keypos+1);
     // set contents of our span element
    document.getElementById('paramsresult').innerHTML = str1;
    }
  }



function clearparamsresult()
  {
  document.getElementById('paramsresult').innerHTML = "" ;
  }


function fixtypechange(ndx)
  {
  // update the enabled/disabled status of the text fields
  // according to type
  var elt;
  var eltiw;
  var eltow;
  var eltoa;
  var eltok;
  var x;
  elt   = document.getElementById("p" + ndx + "type");
  eltiw = document.getElementById("p" + ndx + "iw");
  eltow = document.getElementById("p" + ndx + "ow");
  eltoa = document.getElementById("p" + ndx + "oa");
  eltok = document.getElementById("p" + ndx + "ok");
  x = elt.selectedIndex;
  if (x==1)
    {
    // input
    eltiw.disabled=0;
    eltow.disabled=1;
    eltoa.disabled=1;
    eltok.disabled=1;
    }
  else if (x==2)
    {
    // output
    eltiw.disabled=1;
    eltow.disabled=0;
    eltoa.disabled=0;
    eltok.disabled=0;
    }
  else
    {
    // none - or unspecd
    eltiw.disabled=1;
    eltow.disabled=1;
    eltoa.disabled=1;
    eltok.disabled=1;
    }
  }


function clearspecials()
  {
  var port;
  var eltname;
  var elt;
  for (port=1; port<=8; port++)
    {
    eltname="p" + port + "type";
    elt = document.getElementById(eltname);
    elt.selectedIndex = 0;  // none
    // and grey out all the fields; also blank them
    eltname = "p" + port + "iw";
    elt = document.getElementById(eltname);
    elt.value = "";
    elt.disabled=1;
    eltname = "p" + port + "ow";
    elt = document.getElementById(eltname);
    elt.value = "";
    elt.disabled=1;
    eltname = "p" + port + "oa";
    elt = document.getElementById(eltname);
    elt.value = "";
    elt.disabled=1;
    eltname = "p" + port + "ok";
    elt = document.getElementById(eltname);
    elt.value = "";
    elt.disabled=1;
    }
  }


