// modified Sep 23 2010 - had omitted function dorow
// timeouts changed to 10 seconds

// variables controlling section displays: make it an array
// there are 6 sections
var sectionshown = new Array(6);
var sectionname =  new Array(6);
sectionshown[0] = 0;
sectionshown[1] = 0;
sectionshown[2] = 0;
sectionshown[3] = 0;
sectionshown[4] = 0;
sectionshown[5] = 0;
sectionname[0] = "portdiv";
sectionname[1] = "presdiv";
sectionname[2] = "snmpdiv";
sectionname[3] = "ipdiv";
sectionname[4] = "tstparamdiv";
sectionname[5] = "alarmdiv";


function flipmode(ndx)
  {
  // switch from show to hide; and change value of button
  var butelt;
  var divelt;
  var name;
  name = sectionname[ndx];
  butelt = document.getElementById(name + "but");
  divelt = document.getElementById(name);
  if (sectionshown[ndx])
    {
    // change from shown to hidden
    divelt.style.display = "none";
    butelt.value = "Show";
    sectionshown[ndx]=0;
    }
  else
    {
    // change from hidden to shown
    divelt.style.display = "block";
    butelt.value = "Hide";
    sectionshown[ndx]=1;
    }
  }


// put script in the file so can find errors by line number - separate later
// ************************************************************************
// ************************************************************************

// ncconfig.js: Javascript for the configuration page of ADH NETCOM


// XMLHttpRequest objects
var sxinit = false;  // initial sequencer
var sxaction = false; // action routine: no data returned
var cxcfgin = false;  // get info from config.cgi; get data back
var cxcfgout = false;   // send into to config.cgi, get confirmation message

var specials="";  // for params; filled when fetched, if any are there


// get the xmlHttp request object - browser dependent
if (window.XMLHttpRequest)
  {
  sxinit = new XMLHttpRequest();
  sxaction = new XMLHttpRequest();
  cxcfgin = new XMLHttpRequest();
  cxcfgout = new XMLHttpRequest();
  }
else if (window.ActiveXObject)
  {
  sxinit =   new ActiveXObject("Microsoft.XMLHTTP");
  sxaction = new ActiveXObject("Microsoft.XMLHTTP");
  cxcfgin  = new ActiveXObject("Microsoft.XMLHTTP");
  cxcfgout = new ActiveXObject("Microsoft.XMLHTTP");
  }
else
  {
  alert("Browser does not support xmlHttpRequest object - need to upgrade");
  }

// timeoutid's : one for each xmlhHTTP object
var timeoutidinit;
var timeoutidact;
var timeoutidcfgin;
var timeoutidcfgout;
var numtimeouts;  // for sequencer error timeouts
var sequencecount = 18;
var sequencelist = new Array(18);
var sequencendx;
// string tells what to do: start with C or S
// also have + switch divs - followed by the index of the div to use
// if not 0, first close previous; caller closes last one
sequencelist[0] = "CVA";  // main firmware
sequencelist[1]  = "CVR";  // Rabbit firmware
sequencelist[2]  = "SI";    // serial number(s)
sequencelist[3]  = "CIC";  // current IP etc.
sequencelist[4]  = "+0";  // open port info
sequencelist[5]  = "CPT";  // port info
sequencelist[6]  = "+1";  // switch to pressure
sequencelist[7]  = "CPL"  // current values: pressure limits
sequencelist[8]  = "+2";  // switch to SNMP
sequencelist[9]  = "CSX"  // current values: SNMP info
sequencelist[10]  = "CCX"  // current values: SNMP communities
sequencelist[11]  = "+3";  // switch to IP/serial info
sequencelist[12]  = "CIX"  // current values: IP info
sequencelist[13]  = "CMX"  // current values: serial params
sequencelist[14]  = "+4";  // switch to test params
sequencelist[15] = "CTP"  // current values: test params
sequencelist[16]  = "+5";  // switch to alarm bits
sequencelist[17]  = "CRM"  // current values: alarms: params

// don't need alarm list; now in the HTML code itself
var numalarms;
// set numalarms in a script in the main part
// so if add one, don't have to change the js file

function doalert(str)
// really want to put in alert field - later
  {
  alert(str);
  }

function sysalert(str)
// should be impossible; error in Javascript
  {
  alert("SYSTEM ERROR:\n" + str);
  }


function disorenableall(dis)
  {
  // enable or disable all the user buttons - for initializatin
  document.getElementById("fetchport").disabled=dis;
  document.getElementById("fetchpres").disabled=dis;
  document.getElementById("fetchsnmp").disabled=dis;
  document.getElementById("fetchcmun").disabled=dis;
  document.getElementById("fetchip").disabled=dis;
  document.getElementById("fetchcomm").disabled=dis;
  document.getElementById("fetchparams").disabled=dis;
  document.getElementById("fetchlrms").disabled=dis;
  document.getElementById("submitport").disabled=dis;
  document.getElementById("submitpres").disabled=dis;
  document.getElementById("submitsnmp").disabled=dis;
  document.getElementById("submitcmun").disabled=dis;
  document.getElementById("submitip").disabled=dis;
  document.getElementById("submitcomm").disabled=dis;
  document.getElementById("submitparams").disabled=dis;
  document.getElementById("submitlrms").disabled=dis;
  }


function findkeypos(str)
  {
  // return the position of the "key" in str
  // key can be ! or _ or : or ^
  // has to be 0, 1, or 2: else no key, return0
  var pos;
  pos = str.search(/[\!\:\_\^]/);
  if (pos==-1) pos=0;
  if (pos>2) pos=0;
  return pos;
  }


function config_initialize()
  {
  // initialize to keep specials - safer that way
  document.specform.keepspecs[0].checked = 1;
  document.specform.keepspecs[1].checked = 0;
  // start sequencer
  sequencendx=0;
  numtimeouts=0;
  disorenableall(1);  // no user input allowed
  dosequencer();  // will enable buttons and start refresh when done
  }


function dosequencer()
  {
  var url;
  var ajaxmsg;
  var x;
  var ndx;
  x=sequencelist[sequencendx].charAt(0);
  if (x=='+')
    {
    // page switcher
    ndx=sequencelist[sequencendx].charAt(1);
    if (ndx>0) flipmode(ndx-1);
    flipmode(ndx);
    // now proceed to next element of sequence
    sequencendx++;  // can assume no two flips in a row
    x=sequencelist[sequencendx].charAt(0);
    }
  if (x=='C') url="config.cgi";
  else if (x=='S') url="status.cgi";
  else
    {
    doalert("Bad sequencer element - aborting");
    return;
    }
  ajaxmsg = sequencelist[sequencendx].slice(1);  // start after first char
  if ( (sxinit.readyState==4) || (sxinit.readyState==0) )
    {
    sxinit.open("POST", url, true);
    sxinit.onreadystatechange = sxinitreturn;
    sxinit.send(ajaxmsg);
    timeoutidinit = window.setTimeout("timeoutrtninit();", 10000);
    }
  else
    {
    doalert("Sequencer stuck - aborting");
    return;
    }
  }


function timeoutrtninit()
  {
  // get here if sequencer times out - allow 5 before alerting
  sxinit.abort();
  numtimeouts++;
  if (numtimeouts>=5)
    doalert("Warning: initializer has failed " + numtimeouts + " times so far");
  dosequencer();  // continue to try
  }

function sxinitreturn()
  {
  var str0;
  var keypos;
  var str1;
  var splitstr;
  // check to see if finished
  if ( (sxinit.readyState==4) && (sxinit.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidinit);
    numtimeouts=0;
    str0 = sxinit.responseText;
    keypos = findkeypos(str0);
    if (str0.charAt(keypos) != ":")
      {
      // error return - should be impossible
      doalert("Unexpected response [" + str0 + "]");
      dosequencer();  // keep retrying
      return;
      }
    // here, is ok
    // we know where it came from: don't need to parse
    str1 = str0.slice(keypos+1);
    badresp=0;  // default

    if (sequencendx==0)
	{
	// VA to config: get main firmware
	splitarray = str1.split("$");
	if (splitarray.length!=4) badresp=1;
	document.getElementById("mainfw").innerHTML = splitarray[0];
	}
    else if (sequencendx==1)
	{
	// VR to config: get comm firmware
	document.getElementById("commfw").innerHTML = str1;
	}
    else if (sequencendx==2)
	{
	// I to status: get serial numbers
	splitarray = str1.split(";");
	if (splitarray.length!=3) badresp=1;
	document.getElementById("sernum").innerHTML = splitarray[2];
	}
    else if (sequencendx==3)
	{
	// IC to config: current IP etc.
	splitarray = str1.split(";");
	if (splitarray.length!=6) badresp=1;
	document.getElementById('currentip').innerHTML = splitarray[0];
	document.getElementById('currentmask').innerHTML = splitarray[1];
	document.getElementById('currentgate').innerHTML = splitarray[2];
	document.getElementById('currentname').innerHTML = splitarray[3];
	document.getElementById('currentmac').innerHTML = splitarray[4];
	}

    else if (sequencendx==5)
	{
	// PT to config: port info
	badresp = parseports(str1);
	}
    else if (sequencendx==7)
	{
	// PL to config: pressure limits
	badresp = parsepres(str1);  // puts in place
	}

    else if (sequencendx==9)
	{
	// SX to config: SNMP info
	badresp = parsesnmp(str1);  // puts in place
	}
    else if (sequencendx==10)
	{
	// CX to config: SNMP communities
	badresp = parsecmun(str1);  // puts in place
	}

    else if (sequencendx==12)
	{
	// IX to config: IP info
	badresp = parseip(str1);  // puts in place
	}
    else if (sequencendx==13)
	{
	// MX to config: serial params
	badresp = parsecomm(str1);  // puts in place
	}
    else if (sequencendx==15)
	{
	// TP to config: test params
	badresp = parseparams(str1);  // puts in place
	}
    else if (sequencendx==17)
	{
	// RM to config: bit-mapped alarm configuration
	badresp = parselrms(str1);  // puts in place
	}
    else badresp=0;  // div switch
    if (badresp) doalert("Bad response: [" + str0 + "]");
    if (sequencendx==17)
	{
	// end of sequencer
	sequencendx=0;
	flipmode(5);  // disable the last one
	config_endinit();
	}
    else
	{
	sequencendx++;
	dosequencer();
	}
    }
  }

function config_endinit()
  {
  // get here when initialization is done
  var elt;
  disorenableall(0);  // user input allowed
  }




var portlrms = new Array(9);
// use arrays for special bitmasks
// easier to store them and then distribute to the checkboxes
// can use a single one for all three
// use indice 1-8 only; easier to structure code that way
// index N is the alarm bits for port N
// one var for each port
// these are NOT primary - used only for storage when fetching data
// are not maintained when boxes are clicked




// table for general alarms: do as in NC8
// making it easier to add rows etc.
var numalarms = 9
var lrmlist=new Array(9);
lrmlist[0]  =  "1:  internal leak";
lrmlist[1]  =  "2:  high duty cycle";
lrmlist[2]  =  "3:  low pressure";
lrmlist[3]  =  "4:  high pressure";
lrmlist[4]  =  "5:  low temperature";
lrmlist[5]  =  "6:  high temperature";
lrmlist[6]  =  "7:  EEROM corrupted";
lrmlist[7]  =  "8:  Unable to pressurize";
lrmlist[8]  =  "9:  Switched operating mode";


function byteflip(x)
  {
  // works on 16-bit integers: flip the bytes
  var low, high;
  low = x&0xff;
  high = (x>>8) & 0xff;
  return ( (low<<8) | high);
  }


function maketable()
  {
// see www.webreference.com/js/column44
// says there we need tbody in order to get table to work
// and didn't work with form outside it; try putting whole thing in here
  var ndx;
  var tbodyobj;
  var rowelt;
  var rowsub1;
  var name1;
  var rowsub2;
  var box2;
  var rowsub3;
  var box3;
  var rowsub4;
  var box4;
  var eltname2;
  var ndxstring;
  var button2;
  var button3;
  var button4;
  var form = document.createElement("form");
  var table = document.createElement("table");
  var header = document.createElement("tr");
  var headersub1 = document.createElement("th");
  var headersub2 = document.createElement("th");
  var headersub3 = document.createElement("th");
  var headersub4 = document.createElement("th");
  tbodyobj = document.createElement("TBODY");

  form.setAttribute("name", "alarmform");
  form.setAttribute("id", "alarmform");
  form.setAttribute("onsubmit", "return false");
  table.setAttribute("border", "1");

  headersub1.appendChild(document.createTextNode("Description"));
  headersub2.appendChild(document.createTextNode("Output 1"));
  headersub3.appendChild(document.createTextNode("Output 2"));
  headersub4.appendChild(document.createTextNode("Output 3"));
  header.appendChild(headersub1);
  header.appendChild(headersub2);
  header.appendChild(headersub3);
  header.appendChild(headersub4);
  tbodyobj.appendChild(header);

  for (ndx=0; ndx<numalarms; ndx++)
    {
    ndxstring = ndx.toString(10);
    rowelt = document.createElement("tr");
    rowsub1 = document.createElement("td");
    rowsub1.setAttribute("align", "center");
    name1 = document.createTextNode(lrmlist[ndx]);
    rowsub1.appendChild(name1);

    rowsub2 = document.createElement("td");
    rowsub3 = document.createElement("td");
    rowsub4 = document.createElement("td");

    box2 = document.createElement("input");
    box2.setAttribute("type", "checkbox");
    eltname2 = "LX" + ndxstring;
    box2.setAttribute("name", eltname2);
    box2.setAttribute("id", eltname2);
    box3 = document.createElement("input");
    box3.setAttribute("type", "checkbox");
    eltname3 = "LY" + ndxstring;
    box3.setAttribute("name", eltname3);
    box3.setAttribute("id", eltname3);
    box4 = document.createElement("input");
    box4.setAttribute("type", "checkbox");
    eltname4 = "LZ" + ndxstring;
    box4.setAttribute("name", eltname4);
    box4.setAttribute("id", eltname4);

    rowsub2.appendChild(box2);
    rowsub3.appendChild(box3);
    rowsub4.appendChild(box4);

    rowelt.appendChild(rowsub1);
    rowelt.appendChild(rowsub2);
    rowelt.appendChild(rowsub3);
    rowelt.appendChild(rowsub4);
    tbodyobj.appendChild(rowelt);
    }
  // now put it in place where it is called
  table.appendChild(tbodyobj);
  form.appendChild(table);
  document.getElementById("tablediv").appendChild(form);
  }





function fetchit(param)
  {
  // send to config.cgi - retrieve info from netcom and put in fields
  if ( (cxcfgin.readyState==4) || (cxcfgin.readyState==0) )
    {
    cxcfgin.open("POST", "config.cgi", true);
    cxcfgin.onreadystatechange = cfginreturn;
    cxcfgin.send(param);
    timeoutidcfgin = window.setTimeout("timeoutcfgin();", 10000);
    }
  else alert("Busy - try again");
  }



function timeoutcfgin()
  {
  doalert("Timed out - retry");
  cxcfgin.abort();
  }




function cfginreturn()
  {
  var str0;
  var keypos;
  var prestr;
  var str1;
  var badresp;
  // check to see if finished
  if ( (cxcfgin.readyState==4) && (cxcfgin.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidcfgin);
    str0 = cxcfgin.responseText;
    keypos = findkeypos(str0);
    if ( (keypos!=2) || (str0.charAt(keypos) != ":") )
      {
      // error return - should be impossible
      doalert("Unexpected response [" + str0 + "]");
      return;
      }
    str1 = str0.slice(keypos+1);
    prestr=str0.slice(0,2);  // tells which command it was
    if (prestr == "IX")  badresp = parseip(str1);
    else if (prestr =="SX") badresp = parsesnmp(str1);
    else if (prestr =="CX") badresp = parsecmun(str1);
    else if (prestr =="PL") badresp = parsepres(str1);
    else if (prestr =="MX") badresp = parsecomm(str1);
    else if (prestr =="TP") badresp = parseparams(str1);
    else if (prestr =="RM") badresp = parselrms(str1);
    else if (prestr =="PT") badresp = parseports(str1);
    else badresp=1;
    if (badresp) doalert("Unexpected response [" + str0 + "]");
    }
  }


function setdhcp(isdhcp)
   {
   // enable or disable the fixed ip fields:
   // dhcp means disabled
   document.ipconfig.ip.disabled = isdhcp;
   document.ipconfig.mask.disabled = isdhcp;
   document.ipconfig.gate.disabled = isdhcp;
   document.ipconfig.mane.disabled = false;  // name always ok
   }


function parseip(instr)
  {
  // return 1 if error
  var splitarray;
  splitarray = instr.split(";");
  // first char is D or F, determines form of response
  if (instr.charAt(0)=="F")
	{
	// F: fixed fields included
	if (splitarray.length != 6) return 1;
	document.ipconfig.DHCP[0].checked=0;
	document.ipconfig.DHCP[1].checked=1;
	setdhcp(0);  // fixed fields enabled
	// use the real data
	document.ipconfig.ip.value = splitarray[1];
	document.ipconfig.mask.value = splitarray[2];
	document.ipconfig.gate.value = splitarray[3];
	document.ipconfig.mane.value = splitarray[4];
	return 0;
	}
  else if (instr.charAt(0)=='D')
	{
	// DHCP only
	if (splitarray.length != 3) return 1;
	document.ipconfig.DHCP[0].checked=1;
	document.ipconfig.DHCP[1].checked=0;
	setdhcp(1);  // fixed fields disabled
	// dhcp: kill the fixed fields; no incoming data
	document.ipconfig.ip.value = "";
	document.ipconfig.mask.value = "";
	document.ipconfig.gate.value = "";
	document.ipconfig.mane.value = splitarray[1];
	return 0;
	}
  else return 1;
    }






function parsesnmp(instr)
  {
  // return 1 if bad
  var splitarray;
  splitarray = instr.split(";");
  if (splitarray.length != 4) return 1;
    // insert into form
  document.snmpparams.sn.value = splitarray[0];
  document.snmpparams.sl.value = splitarray[1];
  document.snmpparams.sc.value = splitarray[2];
  return 0;
  }

function parsecmun(instr)
  {
  // return 1 if bad
  var splitarray;
  splitarray = instr.split(";");
  if (splitarray.length != 3) return 1;
  // insert into form
  document.cmunparams.rc.value = splitarray[0];
  document.cmunparams.wc.value = splitarray[1];
  return 0;
  }

function parsepres(instr)
  {
  // return 1 if bad
  var splitarray;
  var ismetric;
  splitarray = instr.split(";");
  if (splitarray.length != 6) return 1;
  // first fields is now E or M:
  if (splitarray[0]=="E")
	{
	document.preslimits.units.selectedIndex=0;
	ismetric=0;
	}
  else if (splitarray[0]=="M")
	{
	document.preslimits.units.selectedIndex=1;
	ismetric=1;
	}
  else return 1;
  // insert into form: if PSI divide by 100; else is just whole mbars
  if (ismetric)
      {
      document.preslimits.la.value = splitarray[1];
      document.preslimits.ll.value = splitarray[2];
      document.preslimits.ul.value = splitarray[3];
      document.preslimits.ua.value = splitarray[4];
      }
  else
      {
      document.preslimits.la.value = splitarray[1] / 100 ;
      document.preslimits.ll.value = splitarray[2] / 100 ;
      document.preslimits.ul.value = splitarray[3] / 100 ;
      document.preslimits.ua.value = splitarray[4] / 100 ;
      }
  return 0;
  }



function parsecomm(instr)
  {
  var x;
  var ndx;
  var ok;
  ok=1;
  x=instr.charAt(0);  // RS422A: XSAM - no M now
  ndx="XSA".indexOf(x);
  if (ndx==-1) ok=0;
  else document.commconfig.type422a.selectedIndex=ndx;
  x=instr.charAt(1);  // F or S
  if (x=='F') document.commconfig.slow422a.checked=0;
  else if (x=='S') document.commconfig.slow422a.checked=1;
  else ok=0;
  x=instr.charAt(2);  // + or -
  if (x=='+') document.commconfig.pullups422a.checked=1;
  else if (x=='-') document.commconfig.pullups422a.checked=0;
  else ok=0;
  x=instr.charAt(3);  // RS422B: XSAM - no M
  ndx="XSA".indexOf(x);
  if (ndx==-1) ok=0;
  else document.commconfig.type422b.selectedIndex=ndx;
  x=instr.charAt(4);  // F or S
  if (x=='F') document.commconfig.slow422b.checked=0;
  else if (x=='S') document.commconfig.slow422b.checked=1;
  else ok=0;
  x=instr.charAt(5);  // RS232: XSAM  -- no M
  ndx="XSA".indexOf(x);
  if (ndx==-1) ok=0;
  else document.commconfig.type232.selectedIndex=ndx;
  x=instr.charAt(6);  // F or S
  if (x=='F') document.commconfig.slow232.checked=0;
  else if (x=='S') document.commconfig.slow232.checked=1;
  else ok=0;

  x=instr.charCodeAt(7);  // SA address, as number
  document.commconfig.saaddress.value = x.toString(16);  // hex


  x=instr.charCodeAt(8);  // as number: metric/range/delims
  x -= 0x41;
  // delims: low 2 bits
  // bit 1 is CR, bit 0 is LF
  // we are not supporting neither in this web page: call it both if see it
  if ( (x&3)==2) document.commconfig.delim.selectedIndex=0;  // cr
  else if ( (x&3)==1) document.commconfig.delim.selectedIndex=1;  // lf
  else document.commconfig.delim.selectedIndex=2;  // crlf
  // bit 5 is metric
  document.commconfig.metric.checked = ( (x&0x20) != 0);
  // no range bits
  // no master type: done elsewhere
  if (!ok) return 1;  // error
  return 0;  // ok
  }


function parseports(instr)
  {
  // return 1 if bad
  var splitarray;   // 9 fields,with terminating semicolon
  var ndx;
  var str;  // one subfield: for easier programming
  var x;
  var eltm;  // mode byte
  var elts;  // switchtime
  var elt1;  // port#type
  var elt2;  // port#disabled
  var elt3;  // port#iptype
  var elt4;  // port#ipaddr
  var ok;
  // should be 9 fields, separated by semicolons
  splitarray = instr.split(";");
  if (splitarray.length != 10) return 1;  // bad
  ok=1;  // so can alert if there is an error
  str = splitarray[0];
  eltm = document.getElementById("modebyte");
  elts = document.getElementById("switchtime");
  if (str=='S')
	{
	eltm.selectedIndex=0;  // standalone
	elts.value="";
	}
  else if (str=='P')
	{
	eltm.selectedIndex=2;  // parallel
	elts.value="";
	}
  else if (str.charAt(0)=='R')
	{
	eltm.selectedIndex=1;  // redundant
	elts.value = str.substring(1);  // omit the R
	}
  else
	{
	eltm.selectedIndex=-1;  // none?
	elts.value="";
	ok=0;
	}
  for (ndx=1; ndx<=8; ndx++)
    {
    str = splitarray[ndx];
    x = str.charAt(0);
    elt1 = document.getElementById("port" + ndx + "type");
    elt2 = document.getElementById("port" + ndx + "disabled");
    elt3 = document.getElementById("port" + ndx + "iptype");
    elt4 = document.getElementById("port" + ndx + "ipaddr");
    if ((x=='i') || (x=='I') )
	{
	// I or i : has IP information following it
	elt1.selectedIndex=1;  // input
	elt2.checked = (x=='i');  // disabled if lower case
	elt2.disabled=0;
	x=str.charAt(1);  // should be X or N or F
	if (x=='X')
	  {
	  elt3.selectedIndex=0; // ip type: none
	  elt4.value="";
	  if (str.length!=2) ok=0;  // extra chars
	  }
	else if (x=='F')
	  {
	  elt3.selectedIndex=1; // ip type: fixed
	  elt4.value = str.substring(2);  // omit the IF
	  }
	else if (x=='N')
	  {
	  elt3.selectedIndex=2; // ip type: name
	  elt4.value = str.substring(2);  // omit the IN
	  }
	else
	  {
	  ok=0;
	  elt3.selectedIndex=-1; //ip type: ???
	  elt4.value="";
	  }
	}
    else if ((str=='o') || (str=='O') )
	{
	elt1.selectedIndex=2;  // output
	elt2.checked = (str=='o');  // disabled if lower case
	elt2.disabled=0;
	elt3.selectedIndex=0; // ip type: none
	elt4.value="";
	}
    else if ((str=='c') || (str=='C') )
	{
	elt1.selectedIndex=3;  // critical output
	elt2.checked = (str=='o');  // disabled if lower case
	elt2.disabled=0;
	elt3.selectedIndex=0; // ip type: none
	elt4.value="";
	}
    else if (str=='B')
	{
	elt1.selectedIndex=4;  // bleeder
	elt2.checked = 0;      // not disabled
	elt2.disabled=1;
	elt3.selectedIndex=0; // ip type: none
	elt4.value="";
	}
    else if (str=='X')
	{
	elt1.selectedIndex=0;  // unused
	elt2.checked = 0;      // not disabled
	elt2.disabled=1;
	elt3.selectedIndex=0; // ip type: none
	elt4.value="";
	}
    else
	{
	ok=0;
	// should be impossible; may as well say unused
	elt1.selectedIndex=0;  // unused
	elt2.checked = 0;      // not disabled
	elt2.disabled=1;
	elt3.selectedIndex=0; // ip type: none
	elt4.value="";
	}
    fixdisabled(ndx);
    } // end for
  if (!ok) return 1;  // bad
  return 0;  // ok
  }


function fixdisabled(ndx)
  {
  // called when type is changed: update the disabled box
  // also disable the ip stuff unless it is an input?
  var elt1;  // port#type
  var elt2;  // port#disabled
  var elt3;  // iptype
  var elt4;  // ipaddr
  var x;
  elt1 = document.getElementById("port" + ndx + "type");
  elt2 = document.getElementById("port" + ndx + "disabled");
  elt3 = document.getElementById("port" + ndx + "iptype");
  elt4 = document.getElementById("port" + ndx + "ipaddr");
  x=elt1.selectedIndex;
  // disabled box alive if 1,2,3: in, out, crit; not if 0=none, or 4=bleed
  if ( (x==1) || (x==2) || (x==3) )
    {
    // leave disabled box check status as it was
    elt2.disabled=0;
    }
  else
    {
    elt2.checked = 0;
    elt2.disabled = 1;
    }
  elt3.disabled = (x!=1);
  elt4.disabled = (x!=1);
  }



function parseparams(instr)
  {
  // return 1 if bad
  var splitarray;
  splitarray = instr.split(";");
  if (splitarray.length != 10) return 1;  // bad
  document.testparams.tpfreq.value = splitarray[0];
  document.testparams.tpdc.value   = splitarray[1];
  document.testparams.tpstall.value = splitarray[2];
  document.testparams.tpsmlr.value = splitarray[3];
  document.testparams.tpiwlr.value = splitarray[4];
  document.testparams.tpowlr.value = splitarray[5];
  document.testparams.tpoalr.value = splitarray[6];
  document.testparams.tpoklr.value = splitarray[7];
  if (splitarray[8] != "")
	{
	// last field not blank: there are specials
	// show the "keep it?" form etc.
	document.getElementById('specialdiv').style.display = "block";
	specials = splitarray[8];
	}
  else
	{
	// last field blank: no specials
	// don't show the keep it stuff
	document.getElementById('specialdiv').style.display = "none";
	specials = ""
	}
  }


function parselrms(instr)
  {
  // return 1 if bad
  var instr;
  var ok;
  var dcthresh;
  var lrmndx;  // which alarm group we are doing: 0,1,2
  var fname;  // first 2 chars: xa,xb,xc
  var ptr;  // for ease - run through the instr
  var portnum;
  var portmask;
  var bitmask;
  var bitnum;
  var bitstring;
  var elt;
  var eltname;
  var val1;
  var val2;
  var val3;
  var ndx;
  var mask;

  // should be a string of 31 pairs: 62 bytes
  ok=1;
  if (instr.length != 62) ok=0;
  // make sure all ok hex digits
  // use reg. ex. match
  if (instr.match(/[^0-9A-Fa-f]/) != null) return 1; // bad form
  // here, is ok: 62 hex digits = 31 bytes of data
  // duty cycle (1 byte), then spec 1, spec2, spec3 (each 8 bytes)
  // then gen1, gen2, gen3 (each 16-bit number)

  dcthresh = parseInt(instr.substring(0,2),16);
  // should never be out of range, but doesn't hurt to check
  if (dcthresh<0)
	{alert("Dutycycle threshold negative: set to 0"); dcthresh=0;}
  if (dcthresh>100)
	{alert("Dutycycle threshold too big: set to 100"); dcthresh=100;}
  // insert dcthreshold into form and save; also save value in global vbl
  dcthreshold = dcthresh;
  document.getElementById("dcthspan").innerHTML = dcthresh.toString(10);

  // next 24 data bytes: 3 groups of 8; do each separately
  ptr=2;  // where in instr we are
  for (lrmndx=0; lrmndx<3; lrmndx++)
    {
    fname = "x" + "abc".charAt(lrmndx);  // xa, xb, xc
    // now get data into portlrms[-]: index 1-8
    for (portnum=1; portnum<=8; portnum++)
	{
	portlrms[portnum] = parseInt(instr.substring(ptr,ptr+2),16);
	ptr += 2;
	}
    // now put into checkboxes; clear the "all" one
    for (bit=0,bitmask=1; bit<8; bit++, bitmask<<=1)
	{
	bitstring = bytetohex(bitmask);  // want "01", not "1"
	eltname = fname + bitstring + "all";
	elt = document.getElementById(eltname);
	elt.checked=0;
	for (portnum=1,portmask=1; portnum<=8; portnum++,portmask<<=1)
	  {
	  eltname = fname + bitstring + "p" + portnum;
          elt = document.getElementById(eltname);
	  elt.checked = ( (portlrms[portnum] & bitmask) != 0);
	  }
	}
    }  // end for lrmndx

  // now do the three general ports
  val1 = parseInt(instr.substring(ptr,ptr+4),16);
  val1 = byteflip(val1);
  ptr += 4;
  val2 = parseInt(instr.substring(ptr,ptr+4),16);
  val2 = byteflip(val2);
  ptr += 4;
  val3 = parseInt(instr.substring(ptr,ptr+4),16);
  val3 = byteflip(val3);
  ptr += 4;
  // use vals to check/uncheck boxes
  for (ndx=0,mask=1; ndx<numalarms; ndx++,mask<<=1)
	{
	ndxstring = ndx.toString(10);
	eltname = "LX" + ndxstring;
	elt = document.getElementById(eltname);
	if (mask&val1) elt.checked = 1; else elt.checked=0;
	eltname = "LY" + ndxstring;
	elt = document.getElementById(eltname);
	if (mask&val2) elt.checked = 1; else elt.checked=0;
	eltname = "LZ" + ndxstring;
	elt = document.getElementById(eltname);
	if (mask&val3) elt.checked = 1; else elt.checked=0;
	}
  return 0;
  }



// ***********************************************

function dorow(fname,mask)
  {
  // fname is form name; just the "xa" or whatever: first chars in names
  // mask is 2-character hex number: "01" etc.
  // try using mask to select the elements
  var checkit;
  var elt;
  var eltname;
  var portnum;
  elt = document.getElementById(fname+mask+"all");
  checkit = elt.checked;
  for (portnum=1; portnum<=8; portnum++)
    {
    eltname=fname+mask+"p"+portnum;
    elt = document.getElementById(eltname);
    elt.checked = checkit;
    }
  }


// ***********************************************

function bytetohex(x)
  {
  // convert to 2-digit hex string; assume is byte
  if (x>=0x10) return x.toString(16);
  else return "0" + x.toString(16);
  }


function wordtohex(x)
  {
  // convert 16-bit integer to 4-digit hex string: low then high
  var high, low;
  low = x&0xff;
  high = (x>>8) & 0xff;
  return bytetohex(low) + bytetohex(high);
  }



function tointeger(fval)
  {
  return parseInt(fval.toFixed(), 10);
  }

function changeunits()
  {
  // called when they change from metric to english or vice versa
  var fval;  // floating point value, from field
  var ival;  // integer value, for conversion
  var mult;
  var conv;
  if (document.preslimits.units.selectedIndex==1)  // new value: PSI to mbar
     {mult=1.0; conv=68.9476;}
  else 
     {mult=100.0; conv = 1.0/68.9476;}
  fval = parseFloat(document.preslimits.la.value,10);
  if (isFinite(fval))
    {
    fval *= conv;
    ival = tointeger(fval*mult);
    fval = ival;
    fval = fval / mult;
    document.preslimits.la.value = fval;
    }
  fval = parseFloat(document.preslimits.ll.value,10);
  if (isFinite(fval))
    {
    fval *= conv;
    ival = tointeger(fval*mult);
    fval = ival;
    fval = fval / mult;
    document.preslimits.ll.value = fval;
    }
  fval = parseFloat(document.preslimits.ua.value,10);
  if (isFinite(fval))
    {
    fval *= conv;
    ival = tointeger(fval*mult);
    fval = ival;
    fval = fval / mult;
    document.preslimits.ua.value = fval;
    }
  fval = parseFloat(document.preslimits.ul.value,10);
  if (isFinite(fval))
    {
    fval *= conv;
    ival = tointeger(fval*mult);
    fval = ival;
    fval = fval / mult;
    document.preslimits.ul.value = fval;
    }
  }

function clearresult(name)
  {
  elt = document.getElementById(name+"result");
  elt.style.display="none";
  }


function submitit(elt,param)
  {
  // submit to config.cgi - triggered by user
  // put error message in the right spot: given by elt
  if ( (cxcfgout.readyState==4) || (cxcfgout.readyState==0) )
     {
     // ok to do it: set up as POST request
     cxcfgout.open("POST", "config.cgi", true);  // asynchronous, POST
     // set up function to be called when state changes
     cxcfgout.onreadystatechange = submititreturn;
     cxcfgout.send(param);
     timeoutidcfgout = window.setTimeout("timeoutcfgout(elt);", 10000);
     }
  else resultalert(elt, "Busy - try again");
  }

function timeoutcfgout(key)
  {
  cxcfgout.abort();
  resultalert(key, "Timed out - retry");
  }


function dosubmitip()
  {
  // note: seems it is not ok to use same string for function and name/id
  var param;
  var xi, xm, xg, xn, xt;
  var isok;
  var key;
  key = "ip";
  // first put together the parameter string
  // make sure no element has a semicolon in it
  isok=1;
  if (document.ipconfig.DHCP[0].checked) xt="D";
  else if (document.ipconfig.DHCP[1].checked) xt="F";
  else
    {
    resultalert(key, "Select DCHP or Fixed");
    return;
    }
  xi = document.ipconfig.ip.value;
  if (xi.indexOf(";") != -1) isok=0;
  xm = document.ipconfig.mask.value;
  if (xm.indexOf(";") != -1) isok=0;
  xg = document.ipconfig.gate.value;
  if (xg.indexOf(";") != -1) isok=0;
  xn = document.ipconfig.mane.value;
  if (xn.indexOf(";") != -1) isok=0;
  if (!isok)
    {
    resultalert(key, "No semicolons, please");
    return;
    }
  if (xt=="F")
    param = "I=" + xt + ";"  + xi + ";" + xm + ";" + xg + ";" + xn + ";" ;
  else
    param = "I=" + xt + ";"  + xn + ";" ;
  submitit(key,param);
  }
  

function dosubmitsnmp()
{
  var param;
  var xn, xl, xc;
  var isok;
  var key;
  key = "snmp"
  // first put together the parameter string
  // make sure no element has a semicolon in it
  isok=1;
  xn = document.snmpparams.sn.value;
  if (xn.indexOf(";") != -1) isok=0;
  xl = document.snmpparams.sl.value;
  if (xl.indexOf(";") != -1) isok=0;
  xc = document.snmpparams.sc.value;
  if (xc.indexOf(";") != -1) isok=0;
  if (!isok)
    {
    resultalert(key, "No semicolons, please");
    return;
    }
  param = "S=" + xn + ";"  + xl + ";" + xc + ";"  ;
  submitit(key,param);
  }


function dosubmitcmun()
  {
  var param;
  var xr, xw;
  var isok;
  var key;
  key = "cmun";
  // first put together the parameter string
  // make sure no element has a semicolon in it
  isok=1;
  xr = document.cmunparams.rc.value;
  if (xr.indexOf(";") != -1) isok=0;
  xw = document.cmunparams.wc.value;
  if (xw.indexOf(";") != -1) isok=0;
  if (!isok)
    {
    resultalert(key, "No semicolons, please");
    return;
    }
  param = "C=" + xr + ";"  + xw + ";"  ;
  submitit(key,param);
  }


function dosubmitpres()
  {
  // either English or metric, depending on form
  var param;
  var fltval;  // from form: floating point, in PSI
  var ila, ill, iul, iua;  // convert to integers
  var mx;  // M or E
  var isok;
  var ismetric;
  var mult;
  var maxval;
  var key;
  key = "pres";
  if (document.preslimits.units.selectedIndex==0)
    {
    // English units
    mult=100.0;   // multiply number in box by 100 to convert to integer
    ismetric=0;
    maxval=10.0;
    mx="E";
    }
  else if (document.preslimits.units.selectedIndex==1)
    {
    // metric units
    mult=1.0;   // number in box in mbars, which is what we submit
    ismetric=1;
    maxval=689.4;  // 10 psi, in mbar
    mx="M";
    }
  else
    {
    resultalert(key,"Must select units");
    return;
    }
  // first put together the parameter string
  if (ismetric) mult=1.0; else mult=100.0;  // multiply by this to get int.
  isok=1;
  if (isok)
    {
    fltval = parseFloat(document.preslimits.la.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<=0.0) isok=0;
    else if (fltval>maxval) isok=0;
    else ila = tointeger(fltval*mult);
    }
  if (isok)
    {
    fltval = parseFloat(document.preslimits.ll.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<=0.0) isok=0;
    else if (fltval>maxval) isok=0;
    else ill = tointeger(fltval*mult);
    }
  if (isok)
    {
    fltval = parseFloat(document.preslimits.ul.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<=0.0) isok=0;
    else if (fltval>maxval) isok=0;
    else iul = tointeger(fltval*mult);
    }
  if (isok)
    {
    fltval = parseFloat(document.preslimits.ua.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<=0.0) isok=0;
    else if (fltval>maxval) isok=0;
    else iua = tointeger(fltval*mult);
    }
  if (!isok)
    {
    resultalert(key, "Error in parameters");
    return;
    }
  param="L=" + mx + ";" + ila + ";" + ill + ";" + iul + ";" + iua + ";" ;
  submitit(key,param);
  }

function dosubmitcomm()
  {
  var param;  // string to submit: only doing some fields now
  var x;  // sub character
  var ndx;
  var ok;
  var xstr;  // from text box
  var y;
  var z;
  ok=1;
  var key;
  key = "comm";
  param = "M=";
  ndx = document.commconfig.type422a.selectedIndex;
  if (ndx==-1)  ok=0;
  else param =  param + "XSA".charAt(ndx);
  if (document.commconfig.slow422a.checked) x="S"; else x="F";
  param = param + x;
  if (document.commconfig.pullups422a.checked) x="+"; else x="-";
  param = param + x;

  ndx = document.commconfig.type422b.selectedIndex;
  if (ndx==-1)  ok=0;
  else param =  param + "XSA".charAt(ndx);
  if (document.commconfig.slow422b.checked) x="S"; else x="F";
  param = param + x;

  ndx = document.commconfig.type232.selectedIndex;
  if (ndx==-1)  ok=0;
  else param =  param + "XSA".charAt(ndx);
  if (document.commconfig.slow232.checked) x="S"; else x="F";
  param = param + x;

  x=document.commconfig.saaddress.value;
  x=parseInt(x,16);  // is in hex!
  if (isNaN(x)) ok=0;
  else   param = param + String.fromCharCode(x);

  x=0x41;
  if (document.commconfig.delim.selectedIndex == 0) x+=2;  // cr
  else if (document.commconfig.delim.selectedIndex == 1) x+=1;  // lf
  else x+=3;  // crlf
  if (document.commconfig.metric.checked) x+=0x20;
  param = param + String.fromCharCode(x);
  param = param+";"

  if (!ok)
    {
    resultalert(key, "Invalid configuration");
    return;
    }
  // now parameter ready: send it
  submitit(key,param);
  }


function dosubmitport()
  {
  var param;  // string to submit: only doing some fields now
  var key;
  var sub;  // substring of parameter
  var x;  // sub character
  var ndx;
  var eltm;  // mode byte
  var elts;  // switchtime
  var elt1;  // port#type
  var elt2;  // port#disabled
  var elt3;  // port#iptype
  var elt4;  // port#ipaddr
  var ok;
  key="port";
  param="P=";
  ok=1;
  eltm = document.getElementById("modebyte");
  elts = document.getElementById("switchtime");
  if (eltm.selectedIndex==0) param = "P=S;" ;
  else if (eltm.selectedIndex==1) param = "P=R" + elts.value + ";" ;
  else if (eltm.selectedIndex==2) param = "P=P;"
  else ok=0;
  for (ndx=1; ndx<=8; ndx++)
    {
    elt1 = document.getElementById("port" + ndx + "type");
    elt2 = document.getElementById("port" + ndx + "disabled");
    elt3 = document.getElementById("port" + ndx + "iptype");
    elt4 = document.getElementById("port" + ndx + "ipaddr");
    if (elt1.selectedIndex==0) x="X";
    else if (elt1.selectedIndex==1) x = (elt2.checked ? "i" : "I");
    else if (elt1.selectedIndex==2) x = (elt2.checked ? "o" : "O");
    else if (elt1.selectedIndex==3) x = (elt2.checked ? "c" : "C");
    else if (elt1.selectedIndex==4) x="B";
    else ok=0;
    if (elt1.selectedIndex==1)
	{
	// I or i : special case

        if (elt3.selectedIndex==0) sub = x + 'X' ;
	else if (elt3.selectedIndex==1) sub = x + 'F' + elt4.value;
	else if (elt3.selectedIndex==2) sub = x + 'N' + elt4.value;
	else ok=0;
	}
    else sub=x;
    param = param + sub + ";"
    }
  if (!ok)
    {
    resultalert(key, "Invalid configuration");
    return;
    }
  // now parameter ready: send it
  submitit(key,param);
  }



function dosubmitparams()
  {
  var param;  // string to submit: only doing some fields now
  var key;

  var fltval;  // from form: floating point, in PSI
  var freq, dc, stall, smlr, iwlr, owlr, oalr, oklr;  // convert to integers
  var isok;
  var minval, maxval;
  var myspecials;
  isok=1;
  // first put together the parameter string
  key="params";
  // so can use same functions: have zerook, maxval
  if (isok)
    {
    // freq: 0-999
    minval=0;
    maxval=999;
    fltval = parseFloat(document.testparams.tpfreq.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else freq = tointeger(fltval);
    }
  if (isok)
    {
    // dc: 1-100
    minval=1;
    maxval=100;
    fltval = parseFloat(document.testparams.tpdc.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else dc = tointeger(fltval);
    }
  if (isok)
    {
    // stall: 1-60
    minval=1;
    maxval=60;
    fltval = parseFloat(document.testparams.tpstall.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else stall = tointeger(fltval);
    }
  if (isok)
    {
    // smlr: 1-250
    minval=1;
    maxval=250;
    fltval = parseFloat(document.testparams.tpsmlr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else smlr = tointeger(fltval);
    }

  if (isok)
    {
    // iwlr: 1-250
    minval=1;
    maxval=250;
    fltval = parseFloat(document.testparams.tpiwlr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else iwlr = tointeger(fltval);
    }
  if (isok)
    {
    // owlr: 1-250
    minval=1;
    maxval=250;
    fltval = parseFloat(document.testparams.tpowlr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else owlr = tointeger(fltval);
    }
  if (isok)
    {
    // oalr: 1-250
    minval=1;
    maxval=250;
    fltval = parseFloat(document.testparams.tpoalr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else oalr = tointeger(fltval);
    }
  if (isok)
    {
    // oklr: 1-999
    minval=1;
    maxval=999;
    fltval = parseFloat(document.testparams.tpoklr.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<minval) isok=0;
    else if (fltval>maxval) isok=0;
    else oklr = tointeger(fltval);
    }
  if (!isok)
    {
    resultalert(key, "Invalid configuration");
    return;
    }
  // parameter string: 3rd param is maxdcparam not used: set to 0
  // no: is now stall: IS used
  // include specials if the yes box is checked
  // if no specials, the var specials is blank, so does not matter which
  if (document.specform.keepspecs[0].checked) myspecials=specials;
  else myspecials="";
  param = "T="+freq+";"+dc+";"+stall+";"
	+smlr+";"+iwlr+";"+owlr+";"+oalr+";"+oklr+";" + myspecials + ";"
  // now parameter ready: send it
  submitit(key,param);
  }



function dosubmitlrms()
  {
  var key;
  var byteval;
  var portnum;
  var portmask
  var bitmask;
  var bitnum;
  var bitstring;
  var lrmndx;  // which alarm group we are doing: 0,1,2
  var fname;  // first 2 chars: xa,xb,xc
  var sendstr;
  var substr;
  var param;
  var val1;
  var val2;
  var val3;
  var ndx;
  var eltname;
  var elt;
  var thisbit;
  key="lrms";
  // first put together the parameter string
  // need to get the three masks
  val1=0;
  val2=0;
  val3=0;
  for (ndx=0,mask=1; ndx<numalarms; ndx++,mask<<=1)
    {
    ndxstring = ndx.toString(10);
    eltname = "LX" + ndxstring;
    elt = document.getElementById(eltname);
    if (elt.checked) val1 |= mask;
    eltname = "LY" + ndxstring;
    elt = document.getElementById(eltname);
    if (elt.checked) val2 |= mask;
    eltname = "LZ" + ndxstring;
    elt = document.getElementById(eltname);
    if (elt.checked) val3 |= mask;
    }
  // now can create the parameter string:
  sendstr = "R=" + bytetohex(dcthreshold);

  for (lrmndx=0; lrmndx<3; lrmndx++)
    {
    fname = "x" + "abc".charAt(lrmndx);  // xa, xb, xc
    substr = "";
    // send port 1, then port 2, etc.
    for (portnum=1,portmask=1; portnum<=8; portnum++,portmask<<=1)
      {
      byteval=0;  // add on bits when they are checked
      for (bit=0,bitmask=1; bit<8; bit++, bitmask<<=1)
	{
	bitstring = bytetohex(bitmask);  // want "01", not "1"
	eltname = fname + bitstring + "p" + portnum;
        elt = document.getElementById(eltname);
	if (elt.checked) byteval |= bitmask;
	}
      substr = substr + bytetohex(byteval);
      }
   sendstr = sendstr + substr;
   }
  // now the three general masks
  sendstr = sendstr+wordtohex(val1)+wordtohex(val2)+wordtohex(val3) + ";";
  // now parameter ready: send it
  submitit(key,sendstr);
  }


function updatedc(delta)
  {
  var elt;
  // add dc to dcthreshold
  // bound by 0,100
  // put new value into span element
  dcthreshold += delta;
  if (dcthreshold<0) dcthreshold=0;
  if (dcthreshold>100) dcthreshold=100;
  elt = document.getElementById("dcthspan");
  elt.innerHTML = dcthreshold.toString(10);
  }




function resultalert(key, msg)
  {
  // key is the "id"
  // use the red block, and insert msg
  var elt;
  var textelt;
  elt = document.getElementById(key + "result");
  textelt = document.getElementById(key + "restext");
  textelt.innerHTML = msg;
  textelt.style.display = "block";
  elt.className = "badresponse";
  elt.style.display = "block";
  }

function submititreturn()
  {
  // getting response from config.cgi to submit action
  var key;
  var elt;
  var textelt;
  var str0;
  var keypos;
  var prestr;
  var str1;
  var resptype;  // 0=normal, 1=rebooting, 2=error
  // check to see if finished
  if ( (cxcfgout.readyState==4) && (cxcfgout.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidcfgout);
    str0 = cxcfgout.responseText;
    keypos = findkeypos(str0);
    if (keypos!=2)
      {
      // error return - should be impossible
      // don't know where it came from, so can't put in right place
      doalert("Unexpected response [" + str0 + "]");
      return;
      }
    str1 = str0.slice(3);
    prestr=str0.slice(0,2);  // tells which command it was
    if (prestr == "I=")     key = "ip";
    else if (prestr =="S=") key = "snmp";
    else if (prestr =="C=") key = "cmun";
    else if (prestr =="L=") key = "pres";
    else if (prestr =="M=") key = "comm";
    else if (prestr =="P=") key = "port";
    else if (prestr =="T=") key = "params";
    else if (prestr =="R=") key = "lrms";
    else
      {
      // error return - should be impossible
      // don't know where it came from, so can't put in right place
      doalert("Unexpected response [" + str0 + "]");
      return;
      }
    elt = document.getElementById(key + "result");
    textelt = document.getElementById(key + "restext");
    if (str0.charAt(2) == '_') resptype=0;
    else if (str0.charAt(2) == '^') resptype=1;
    else if (str0.charAt(2) == '!') resptype=2;
    else
      {
      // error return - should be impossible
      resultalert(elt, "Unexpected response [" + str0 + "]");
      return;
      }
    textelt.innerHTML = str1;
    textelt.style.display = "block";
    if (resptype==0) elt.className = "goodresponse";
    else if (resptype==1) elt.className = "warnresponse";
    else elt.className = "badresponse";
    elt.style.display = "block";
    }
  }



